import React from 'react';
import { SchemaInitializerItemOptions, useCollectionDataSource } from '@nocobase/client';
import { CollectionFieldInitializers } from '../components/CollectionFieldInitializers';
declare const _default: {
    title: string;
    type: string;
    fieldset: {
        collection: {
            "x-reactions": (string | {
                target: string;
                effects: string[];
                fulfill: {
                    state: {
                        value: any[];
                    };
                };
            })[];
            type: string;
            title: string;
            required: boolean;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                placeholder: string;
            };
        };
        mode: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                options: {
                    label: string;
                    value: number;
                }[];
                placeholder: string;
            };
            required: boolean;
            'x-reactions': ({
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                        disabled?: undefined;
                    };
                };
                target?: undefined;
            } | {
                target: string;
                fulfill: {
                    state: {
                        disabled: string;
                        visible?: undefined;
                    };
                };
                dependencies?: undefined;
            })[];
        };
        changed: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                mode: string;
                placeholder: string;
                filter(field: any): boolean;
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
        condition: {
            title: string;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
            type: string;
            'x-decorator': string;
            'x-decorator-props': {
                labelAlign: string;
                className: string;
            };
            'x-component': string;
            'x-component-props': {
                useProps(): {
                    options: any[];
                    className: string;
                };
                dynamicComponent: string;
            };
        };
    };
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {
        FieldsSelect: React.MemoExoticComponent<React.FunctionComponent<Pick<any, string | number | symbol>>>;
    };
    getOptions(config: any, types: any): any[];
    useInitializers(config: any): SchemaInitializerItemOptions | null;
    initializers: {
        CollectionFieldInitializers: typeof CollectionFieldInitializers;
    };
};
export default _default;
