"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _react2() {
  const data = require("@formily/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _collection = require("../schemas/collection");

var _variable = require("../variable");

var _CollectionBlockInitializer = require("../components/CollectionBlockInitializer");

var _CollectionFieldInitializers = require("../components/CollectionFieldInitializers");

var _locale = require("../locale");

const _excluded = ["filter"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const FieldsSelect = (0, _react2().observer)(props => {
  const _props$filter = props.filter,
        filter = _props$filter === void 0 ? () => true : _props$filter,
        others = _objectWithoutProperties(props, _excluded);

  const compile = (0, _client().useCompile)();

  const _useCollectionManager = (0, _client().useCollectionManager)(),
        getCollectionFields = _useCollectionManager.getCollectionFields;

  const _useForm = (0, _react2().useForm)(),
        values = _useForm.values;

  const fields = getCollectionFields(values === null || values === void 0 ? void 0 : values.collection);
  return _react().default.createElement(_antd().Select, _objectSpread({}, others), fields.filter(filter).map(field => {
    var _field$uiSchema;

    return _react().default.createElement(_antd().Select.Option, {
      key: field.name,
      value: field.name
    }, compile((_field$uiSchema = field.uiSchema) === null || _field$uiSchema === void 0 ? void 0 : _field$uiSchema.title));
  }));
});
const COLLECTION_TRIGGER_MODE = {
  CREATED: 1,
  UPDATED: 2,
  SAVED: 3,
  DELETED: 4
};
const collectionModeOptions = [{
  label: `{{t("After record added", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.CREATED
}, {
  label: `{{t("After record updated", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.UPDATED
}, {
  label: `{{t("After record added or updated", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.SAVED
}, {
  label: `{{t("After record deleted", { ns: "${_locale.NAMESPACE}" })}}`,
  value: COLLECTION_TRIGGER_MODE.DELETED
}];
var _default = {
  title: `{{t("Collection event", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'collection',
  fieldset: {
    collection: _objectSpread(_objectSpread({}, _collection.collection), {}, {
      ['x-reactions']: [..._collection.collection['x-reactions'], {
        target: 'changed',
        effects: ['onFieldValueChange'],
        fulfill: {
          state: {
            value: []
          }
        }
      }, {
        target: 'condition',
        effects: ['onFieldValueChange'],
        fulfill: {
          state: {
            value: null
          }
        }
      }]
    }),
    mode: {
      type: 'number',
      title: `{{t("Trigger on", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        options: collectionModeOptions,
        placeholder: `{{t("Trigger on", { ns: "${_locale.NAMESPACE}" })}}`
      },
      required: true,
      'x-reactions': [{
        dependencies: ['collection'],
        fulfill: {
          state: {
            visible: '{{!!$deps[0]}}'
          }
        }
      }, {
        target: 'changed',
        fulfill: {
          state: {
            disabled: `{{!($self.value & ${COLLECTION_TRIGGER_MODE.UPDATED})}}`
          }
        }
      }]
    },
    changed: {
      type: 'array',
      title: `{{t("Changed fields", { ns: "${_locale.NAMESPACE}" })}}`,
      description: `{{t("Triggered only if one of the selected fields changes. If unselected, it means that it will be triggered when any field changes. When record is added or deleted, any field is considered to have been changed.", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'FieldsSelect',
      'x-component-props': {
        mode: 'multiple',
        placeholder: '{{t("Select Field")}}',

        filter(field) {
          return !field.hidden && (field.uiSchema ? !field.uiSchema['x-read-pretty'] : true) && !['linkTo', 'hasOne', 'hasMany', 'belongsToMany'].includes(field.type);
        }

      },
      'x-reactions': [{
        dependencies: ['collection'],
        fulfill: {
          state: {
            visible: '{{!!$deps[0]}}'
          }
        }
      }]
    },
    condition: _objectSpread(_objectSpread({}, _collection.filter), {}, {
      title: `{{t("Only triggers when match conditions", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-reactions': [{
        dependencies: ['collection'],
        fulfill: {
          state: {
            visible: '{{!!$deps[0]}}'
          }
        }
      }]
    }) // appends: {
    //   type: 'array',
    //   title: `{{t("Prefetch fields", { ns: "${NAMESPACE}" })}}`,
    //   description: `{{t("Triggered only if one of the selected fields changes. If unselected, it means that it will be triggered when any field changes. When record is added or deleted, any field is considered to have been changed.", { ns: "${NAMESPACE}" })}}`,
    //   'x-decorator': 'FormItem',
    //   'x-component': 'FieldsSelect',
    //   'x-component-props': {
    //     mode: 'multiple',
    //     placeholder: '{{t("Select Field")}}'
    //   },
    //   'x-reactions': [
    //     {
    //       dependencies: ['collection'],
    //       fulfill: {
    //         state: {
    //           visible: '{{!!$deps[0]}}',
    //         },
    //       }
    //     },
    //   ]
    // },

  },
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    FieldsSelect
  },

  getOptions(config, types) {
    const _useWorkflowTranslati = (0, _locale.useWorkflowTranslation)(),
          t = _useWorkflowTranslati.t;

    const fieldOptions = (0, _variable.useCollectionFieldOptions)({
      collection: config.collection,
      types
    });
    const options = [...((fieldOptions === null || fieldOptions === void 0 ? void 0 : fieldOptions.length) ? [{
      label: t('Trigger data'),
      key: 'data',
      value: 'data',
      children: fieldOptions
    }] : [])];
    return options;
  },

  useInitializers(config) {
    if (!config.collection) {
      return null;
    }

    return {
      type: 'item',
      title: `{{t("Trigger data", { ns: "${_locale.NAMESPACE}" })}}`,
      component: _CollectionBlockInitializer.CollectionBlockInitializer,
      collection: config.collection,
      dataSource: '{{$context.data}}'
    };
  },

  initializers: {
    CollectionFieldInitializers: _CollectionFieldInitializers.CollectionFieldInitializers
  }
};
exports.default = _default;