"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _evaluators() {
  const data = _interopRequireDefault(require("@nocobase/evaluators"));

  _evaluators = function _evaluators() {
    return data;
  };

  return data;
}

var _constants = require("../constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = {
  run(node, prevJob, processor) {
    return _asyncToGenerator(function* () {
      const _ref = node.config || {},
            _ref$engine = _ref.engine,
            engine = _ref$engine === void 0 ? 'math.js' : _ref$engine,
            _ref$expression = _ref.expression,
            expression = _ref$expression === void 0 ? '' : _ref$expression;

      const evaluator = _evaluators().default.get(engine);

      const scope = processor.getScope();

      try {
        const result = evaluator && expression ? evaluator(expression, scope) : null;
        return {
          result,
          status: _constants.JOB_STATUS.RESOLVED
        };
      } catch (e) {
        return {
          result: e.toString(),
          status: _constants.JOB_STATUS.ERROR
        };
      }
    })();
  }

};
exports.default = _default;