"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.submit = submit;

function _actions() {
  const data = require("@nocobase/actions");

  _actions = function _actions() {
    return data;
  };

  return data;
}

var _constants = require("../../constants");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function submit(_x, _x2) {
  return _submit.apply(this, arguments);
}

function _submit() {
  _submit = _asyncToGenerator(function* (context, next) {
    const repository = _actions().utils.getRepositoryFromParams(context);

    const _context$action$param = context.action.params,
          filterByTk = _context$action$param.filterByTk,
          values = _context$action$param.values;
    const currentUser = context.state.currentUser;

    if (!currentUser) {
      return context.throw(401);
    }

    const plugin = context.app.pm.get('workflow');
    const userJob = yield context.db.sequelize.transaction( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (transaction) {
        var _instance$node$config2;

        const instance = yield repository.findOne({
          filterByTk,
          // filter: {
          //   userId: currentUser?.id
          // },
          appends: ['job', 'node', 'execution', 'workflow'],
          context,
          transaction
        });

        if (!instance) {
          return context.throw(404);
        }

        const _instance$node$config = instance.node.config.actions,
              actions = _instance$node$config === void 0 ? [] : _instance$node$config; // NOTE: validate status

        if (instance.status !== _constants.JOB_STATUS.PENDING || instance.job.status !== _constants.JOB_STATUS.PENDING || instance.execution.status !== _constants.EXECUTION_STATUS.STARTED || !instance.workflow.enabled || !actions.includes(values.status)) {
          return context.throw(400);
        }

        instance.execution.workflow = instance.workflow;
        const processor = plugin.createProcessor(instance.execution, {
          transaction
        });
        yield processor.prepare();
        const assignees = processor.getParsedValue((_instance$node$config2 = instance.node.config.assignees) !== null && _instance$node$config2 !== void 0 ? _instance$node$config2 : []);

        if (!assignees.includes(currentUser.id) || instance.userId !== currentUser.id) {
          return context.throw(403);
        } // NOTE: validate assignee


        yield instance.update({
          status: values.status,
          result: values.result
        }, {
          transaction
        });
        return instance;
      });

      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }()); // await transaction.commit();

    context.body = userJob;
    context.status = 202;
    yield next();
    userJob.job.latestUserJob = userJob; // NOTE: resume the process and no `await` for quick returning

    plugin.resume(userJob.job);
  });
  return _submit.apply(this, arguments);
}